{
    volScalarField rAU = 1.0/UEqn.A();
    surfaceScalarField rAUf = fvc::interpolate(rAU);

    U = rAU*UEqn.H();
    surfaceScalarField phiU("phiU", (fvc::interpolate(U) & mesh.Sf()));

    phi = phiU +
    (
        fvc::interpolate(interface.sigmaK())*fvc::snGrad(gamma)
      - ghf*fvc::snGrad(rho)
    )*rAUf*mesh.magSf();

    if (pd.needReference())
    {

        fvc::makeRelative(phi, U);
        adjustPhi(phi, U, pd);
        fvc::makeAbsolute(phi, U);
    }

    //adjustPhi(phi, U, pd);

    for(int nonOrth=0; nonOrth<=nNonOrthCorr; nonOrth++)
    {

        fvScalarMatrix pdEqn
        (
            fvm::laplacian(rAUf, pd) == fvc::div(phi)
        );


        pdEqn.setReference(pdRefCell, pdRefValue);

        if (corr == nCorr-1 && nonOrth == nNonOrthCorr)
        {Info << "p10" << endl;
	
            pdEqn.solve(mesh.solver(pd.name() + "Final"));
        }
        else
        {Info << "p11" << endl;
            pdEqn.solve(mesh.solver(pd.name()));
        }

        if (nonOrth == nNonOrthCorr)
        {Info << "p12" << endl;
            phi -= pdEqn.flux();
        }
    }

    #include "continuityErrs.H"

    // Make the fluxes relative to the mesh motion
    fvc::makeRelative(phi, U);    
    fvc::makeRelative(phiU, U);

    U += rAU*fvc::reconstruct((phi - phiU)/rAUf);
    U.correctBoundaryConditions();
}
